/***************************************************************************
                          resource.h  -  description
                             -------------------
    begin                : Don Jun 22 21:00:19 CEST 2000
    copyright            : (C) 2000 by Helmut Steger
    email                : hel.steger@rolmail.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef RESOURCE_H
#define RESOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#define VERSION_DATE	"03 Jun 2001"

///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands


///////////////////////////////////////////////////////////////////
// COMMAND VALUES FOR MENUBAR AND TOOLBAR ENTRIES


///////////////////////////////////////////////////////////////////
// File-menu entries
#define ID_FILE_OPEN                10010
#define ID_FILE_SAVE                10020
#define ID_FILE_LOAD_PALETTE		10030
#define ID_FILE_PRINT               10040
#define ID_FILE_SAVEPIC_FORMAT		10050	// list with up to 50 formats
#define ID_FILE_GENERAL_SETTINGS    10200
#define ID_FILE_QUIT                10210

///////////////////////////////////////////////////////////////////
// Iso-menu entries
#define ID_ISO_DISPLAY_LINES		11010
#define ID_ISO_DISPLAY_COLORLINES	11020
#define ID_ISO_DISPLAY_AREAS		11030
#define ID_ISO_DISPLAY_BARS			11040

#define ID_ISO_SMOOTHING_NONE		11050
#define ID_ISO_SMOOTHING_1			11051
#define ID_ISO_SMOOTHING_MORE		11100
#define ID_ISO_SMOOTHING_LESS		11101

#define ID_ISO_AREAOUTLINE			11070
#define ID_ISO_AUTOHEIGHT			11080
#define ID_ISO_HORLINES				11090
#define ID_ISO_VERLINES				11100
#define ID_ISO_FULLSCREEN			11110
#define ID_ISO_SETTINGS				11120

///////////////////////////////////////////////////////////////////
// Fract-menu entries
#define ID_FRACT_FRACTTYPE_MANDEL	12010
#define ID_FRACT_FRACTTYPE_JULIA	12020
#define ID_FRACT_DEFAULT_COORDS		12030
#define ID_FRACT_ADJUST_WINSIZE		12040
#define ID_FRACT_ADJUST_REAL		12050
#define ID_FRACT_ADJUST_IMAG		12060
#define ID_FRACT_SETTINGS			12070

///////////////////////////////////////////////////////////////////
// View-menu entries                    
#define ID_VIEW_TOOLBAR             13010
#define ID_VIEW_STATUSBAR           13020

///////////////////////////////////////////////////////////////////
// Help-menu entries
#define ID_HELP_ABOUT               1002
#define ID_HELP_ABOUT_QT            1003


///////////////////////////////////////////////////////////////////
// General application values

#define IDS_STATUS_DEFAULT          "Ready."


#define IDS_WHATSTHIS_LINEMODE		"Sets iso drawing mode to lines:\n" \
									"single lines are drawn (one color)"

#define IDS_WHATSTHIS_LINECOLORMODE	"Sets iso drawing mode to color lines:\n" \
									"single lines are drawn (multicolor)"

#define IDS_WHATSTHIS_AREAMODE		"Sets iso drawing mode to areas:\n" \
									"colored areas are drawn (you can switch\n" \
									"outline on/off"

#define IDS_WHATSTHIS_BARMODE		"Sets iso drawing mode to 3d bars:\n" \
									"colored 3d bars are drawn (you can switch\n" \
									"outline on/off"

#define IDS_WHATSTHIS_OUTLINE		"Draws areas with black outline\n" \
									"(used in area mode and bars 3d mode)"

#define IDS_WHATSTHIS_SMOOTHING_MORE	"increase iso smoothing"

#define IDS_WHATSTHIS_SMOOTHING_LESS	"reduce iso smoothing"

#define IDS_WHATSTHIS_OPEN_PALETTE		"read color palette from file"
									
#define IDS_WHATSTHIS_FULLSCREEN		"switch fullscreen mode on/off\n" \
										"for iso window"


#define IDS_JULIACONST_ACTIVATE_BUTTON	"Activate this button to enable interactive " \
										"changing of the julia constants."

#define IDS_JULIACONST_INTERACTIVE_MODE	"Move mouse in fractal window and press the " \
										"right mouse button to change the constants " \
										"interactively."

#define IDS_JULIACONST_BUTTON_TOOLTIP	"When this button is activated you can change\n" \
										"the julia constants interactively: select the\n" \
										"coordinates by pressing the right mouse button\n" \
										"in the fractal window and move the mouse pointer."
										
										
																			
#endif // RESOURCE_H
